'use strict';

var Curry = require("bs-platform/lib/js/curry.js");
var React = require("react");
var Belt_Option = require("bs-platform/lib/js/belt_Option.js");
var Caml_option = require("bs-platform/lib/js/caml_option.js");

function GenerateContainer(Client, ReadFragment, Model) {
  var FragmentConfig = Curry._1(ReadFragment, Model.Fragment.Fields);
  var get = function (fragmentType, id, fragmentName) {
    return Curry._4(FragmentConfig.read, Client.instance, fragmentType + (":" + id), fragmentName, /* () */0);
  };
  var ApolloFragment$GenerateContainer$InnerContainer = function (Props) {
    var fragmentType = Props.fragmentType;
    var id = Props.id;
    var failComponent = Props.failComponent;
    var fragmentName = Props.fragmentName;
    var children = Props.children;
    var match = get(fragmentType, id, fragmentName);
    if (match !== undefined) {
      return Curry._1(children, Caml_option.valFromOption(match));
    } else if (failComponent !== undefined) {
      return Caml_option.valFromOption(failComponent);
    } else {
      return React.createElement("div", undefined, "No data Loaded");
    }
  };
  var getById = function (id) {
    return get(Model.fragmentType, Curry._1(Model.getUUIDFromId, id), Model.fragmentName);
  };
  var getRecordById = function (id) {
    var __x = get(Model.fragmentType, Curry._1(Model.getUUIDFromId, id), Model.fragmentName);
    return Belt_Option.map(__x, Model.Record.fromObject);
  };
  var ApolloFragment$GenerateContainer = function (Props) {
    var id = Props.id;
    var children = Props.children;
    return React.createElement(ApolloFragment$GenerateContainer$InnerContainer, {
                fragmentType: Model.fragmentType,
                id: id,
                fragmentName: Model.fragmentName,
                children: (function (data) {
                    return Curry._1(children, Curry._1(Model.Record.fromObject, data));
                  })
              });
  };
  return {
          getById: getById,
          getRecordById: getRecordById,
          make: ApolloFragment$GenerateContainer
        };
}

exports.GenerateContainer = GenerateContainer;
/* react Not a pure module */
